================================================================================
==== Standard Tags
================================================================================
Package:        $package$
Class:          $class$
Version:        $version$
Date:           $date$
Author:         $author$
Company:        $company$

Project Name:   $project_name$
Source Path:    $src_path$
Template Path:  $template_path$
Execution Path: $execution_path$

Argument Prefix:        $arg$
Member Variable Prefix: $var$

================================================================================
==== Constants
================================================================================
Two lines:%EOL%->line1%EOL%->line2
Only ones : 10%BACKSPACE%10%BACKSPACE%10%BACKSPACE%10%BACKSPACE%1

================================================================================
==== Include: $execution_path$\testing\_include_header.tpl
================================================================================
$include('$execution_path$\testing\_include_header.tpl')$

================================================================================
==== Properties Derived Tags
================================================================================
Max Property length:      $lpad('$maxproplen$', 3)$ chars
Max Property Type length: $lpad('$maxtypelen$', 3)$ chars
Max Field Name length:    $lpad('$maxfieldlen$', 3)$ chars
Max Field Type length:    $lpad('$maxfieldtypelen$', 3)$ chars

================================================================================
==== Property Array Tags (test with indexes 0 and 3
================================================================================
Property 0: $propertytype[0]$ $property[0]$ $Property[0]$ $fieldname[0]$ $fieldtype[0]$ $fieldisnull[0]$
Property 3: $propertytype[3]$ $property[3]$ $Property[3]$ $fieldname[3]$ $fieldtype[3]$ $fieldisnull[3]$

Property 0: $propertytype_rpad[0]$ $property_rpad[0]$ $Property_rpad[0]$ $fieldname_rpad[0]$ $fieldtype_rpad[0]$ $fieldisnull[0]$
Property 3: $propertytype_rpad[3]$ $property_rpad[3]$ $Property_rpad[3]$ $fieldname_rpad[3]$ $fieldtype_rpad[3]$ $fieldisnull[3]$

================================================================================
==== Property Loops Test 1. Full property loop
================================================================================
$doproperty$
 $index$ $count$ $pre$ $propertytype$ $property$ $Property$ $fieldname$ $fieldtype$ $fieldisnull$
$loop$

================================================================================
==== Property Loops Test 2. Full property loop with right padded names
================================================================================
$doproperty$
 $index$ $count$ $pre$ $propertytype_rpad$ $property_rpad$ $Property_rpad$ $fieldname_rpad$ $fieldtype_rpad$ $fieldisnull$
$loop$

================================================================================
==== Property Loops Test 3. Same as loop 1 but with array tags
================================================================================
$doproperty$
 $index$ $count$ $pre$ $propertytype[$index$]$ $property[$index$]$ $Property[$index$]$ $fieldname[$index$]$ $fieldtype[$index$]$ $fieldisnull[$index$]$
$loop$

================================================================================
==== Property Loops Test 3. Same as loop 2 but with array tags
================================================================================
$doproperty$
 $index$ $count$ $pre$ $propertytype_rpad[$index$]$ $property_rpad[$index$]$ $Property_rpad[$index$]$ $fieldname_rpad[$index$]$ $fieldtype_rpad[$index$]$ $fieldisnull[$index$]$
$loop$

================================================================================
==== Inline Property loops Test 1. All properties on one line
================================================================================
--->$ploop(0, $propertycount$, ', ')$$property$$ploop$

================================================================================
==== Inline Property loops Test 2. Dot delimited property indexes
================================================================================
--->$ploop(0, $propertycount$, '.')$$index$$ploop$
--->$ploop(0, $propertycount$, '.', 2, '%BACKSPACE%-')$$index$$ploop$
--->$ploop(0, $propertycount$, ', ', 2, '%EOL%')$$var$$pre$$Property$$ploop$

================================================================================
==== Inline Property loops Test 3. Different first two
================================================================================
--->$ploop(0, 2, ', ')$old_$property$$ploop$, $ploop(2, $propertycount$, ', ')$new_$property$$ploop$

================================================================================
==== Inline Property loops Test 4. Method signature example
================================================================================
public static method ( $ploop(0, $propertycount$, ',%EOL%')$$propertytype_rpad$ $var$$pre$$Property$$ploop$ );

================================================================================
==== Regular Expressions
================================================================================
Unmodified Package Tag  : $package$
Package with backslashes: $regex ('$package$','\.','\')$
Package with backslashes: $regex ('$class$','[A..Z,a..z]([A..Z])','\1')$

================================================================================
==== String Functions
================================================================================
Lower case of "Java"   : $lower('Java')$
Upper case of "Java"   : $upper('Java')$
Upper case of class tag: $upper('$class$')$

// substrings
'cylog',1,2   = $substr('cylog',1,2)$
'cylog',1,200 = $substr('cylog',1,200)$   (returns all remaining characters)
'cylog',3,2   = $substr('cylog',3,2)$
'cylog',3,0   = $substr('cylog',3,0)$
'cylog',1,1   = $substr('cylog',1,1)$
'cylog',2,1   = $substr('cylog',2,1)$
'cylog',3,1   = $substr('cylog',3,1)$
'cylog',4,1   = $substr('cylog',4,1)$
'cylog',5,1   = $substr('cylog',5,1)$
'cylog',6,1   = $substr('cylog',6,1)$

// #12345678# Padding "cylog" to 8 characters, right and left
   #$rpad('cylog',8)$#
   #$lpad('cylog',8)$#

// zero padding
  '1' in 4 chars : $zeropad(1,4)$
 '22' in 4 chars : $zeropad(22,4)$
'123' in 2 chars : $zeropad(123,2)$   (number is longer than the requested number of chars)

// "zero" when the $index$ tag is "0", "not zero" otherwise
$doproperty$
$index$. $equals('$index$','0', 'zero    ','not zero')$
$loop$

# pos and lastpos functions
first 'x' in 'banana'  : $pos('x','banana')$
last  'x' in 'banana'  : $lastpos('x','banana')$
first 'a' in 'banana'  : $pos('a','banana')$
last  'a' in 'banana'  : $lastpos('a','banana')$
first 'ana' in 'banana': $pos('ana','banana')$
last  'ana' in 'banana': $lastpos('ana','banana')$

================================================================================
==== Numerical functions
================================================================================
$doproperty$
$index$ + $count$ = $inc($index$, $count$)$
$loop$

$doproperty$
$index$ - 2 = $dec($index$, 2)$
$loop$

================================================================================
==== Additional custom template tags
================================================================================
temp_tag_0 : $temp_tag_0$
temp_tag_1 : $temp_tag_1$
TEMP_TAG_0 : $TEMP_TAG_0$

================================================================================
==== Switch Definitions
================================================================================
$switchdef('domain1')$
    0 = zero
    1 = one
    2 = two
    3 = three
$switchdef$
// Domain with definitions for 0 to 3 only
$ploop(0, $propertycount$, ', ')$$index$:$switch('domain1','$index$')$$ploop$

$switchdef('domain2')$
    0 = zero
    1 = one
    2 = two
    $default$ = UNKNOWN
$switchdef$
// Domain with defaults:
$ploop(0, $propertycount$, ', ')$$index$:$switch('domain2','$index$')$$ploop$